# !/usr/bin/python3
# _*_coding:utf-8 _*_
""""
# @Time　　:2021/12/20 00:00
# @Author　 : luweisen cv from csdn
# @File　　  :conftest.py
"""
from time import strftime
from typing_extensions import Self

from py._xmlgen import html
import pytest, socket
# from jinja2 import Template

from tslrunner.models import Url

def pytest_collection_modifyitems(items):
    # item表示每个测试用例，解决用例名称中文显示问题
    for item in items:
        item.name = item.name.encode("utf-8").decode("utf-8")
        item._nodeid = item._nodeid.encode("utf-8").decode("utf-8")

@pytest.mark.optionalhook
def pytest_html_results_table_header(cells):
    # cells.insert(1, html.th('用例描述', class_="sortable", col="name"))  # 表头添加Description
    cells.insert(4, html.th('执行时间', class_='sortable time', col='time'))
    # cells.pop(-1)  # 删除link

@pytest.mark.optionalhook
def pytest_html_results_table_row(report, cells):
    # cells.insert(1, html.td(report.description))  # 表头对应的内容
    cells.insert(4, html.td(strftime('%Y-%m-%d %H:%M:%S'), class_='col-time'))
    # cells.pop(-1)  # 删除link列

@pytest.mark.optionalhook
def pytest_html_results_table_html(report, data):   # 不要清除执行成功的用例logs
    if report.passed:
        pass
#         del data[:]
#         data.append(html.div('正常通过用例不抓取日志', class_='empty log'))

@pytest.mark.optionalhook
def pytest_html_report_title(report):
    report.title = "自动化测试报告"

# 修改Environment部分信息，配置测试报告环境信息
def pytest_configure(config):
    # 添加接口地址与项目名称
    config._metadata["项目名称"] = "TACOS控制面板"
    config._metadata["应用名称"] =  "micro-panel"
    config._metadata['接口地址'] = 'https://XX.XXX.XXX'    
    config._metadata['开始时间'] = strftime('%Y-%m-%d %H:%M:%S')
    config._metadata['执行IP地址'] = None #docker容器中无法获取IP地址 socket.getaddrinfo(socket.gethostname(),None)[1][4][0]
    # 删除Java_Home
    #config._metadata.pop("JAVA_HOME")
    config._metadata.pop("Packages")
    config._metadata.pop("Platform")
    config._metadata.pop("Plugins")
    config._metadata.pop("Python")

# 修改Summary部分的信息
def pytest_html_results_summary(prefix, summary, postfix):
    prefix.append([html.th("执行人: "),html.label("默认用户")])


@pytest.mark.hookwrapper
def pytest_runtest_makereport(item, call):
    outcome = yield
    report = outcome.get_result()
    if item.function.__doc__ is None:
        report.description = str(item.function.__name__)
    else:
        report.description = str(item.function.__doc__)
    report.nodeid = report.nodeid.encode("utf-8").decode("utf-8")  # 设置编码显示中文


##增加自定义输出报告
# html_tpl = '''<!DOCTYPE html>
# <html lang="en">
# <head>
#     <meta charset="UTF-8">
#     <title>{{title}}</title>
#     <style>
#       table {border-spacing: 0;}
#       th {background-color: #ccc}
#       td {padding: 5px; border: 1px solid #ccc;}
#     </style>
# </head>
# <body>
#     <h2>{{title}}</h2>
#     <table>
#         <tr> <th>函数名</th> <th>用例id</th> <th>状态</td> <th>用例输出</th> <th>执行时间</th> </tr>
#         {% for item in results %}
#         <tr>
#             <td>{{item.location[2]}}</td>
#             <td>{{item.nodeid}}</td>
#             <td>{{item.outcome.strip()}}</td>
#             <td>{% if item.sections %}{{item.sections[0][1].strip()}}{% endif %}</td>
#             <td>{{item.duration}}</td>
#         </tr>
#         {% endfor %}
#     </table>
# </body>
# </html>'''

# @pytest.mark.hookwrapper
# def pytest_terminal_summary(terminalreporter, exitstatus, config):
#     results = []
#     for status in ['passed', 'failed', 'skipped', 'xfailed', 'xpassed']:
#         if status in terminalreporter.stats:
#             results.extend(terminalreporter.stats[status])

#     html = Template(html_tpl).render(title='测试报告', results=results)

#     with open('report_detail.html', 'w', encoding='utf-8') as f:
#         f.write(html)
