import os, loguru, datetime, time
import json, requests, jmespath, shutil

def send_test_result_to_devops(magicbowIp=''):
    
    test_result={}
    # print("magicbow_ip = " + magicbowIp)
    server_url = os.environ.get('SERVER_URL') or 'http://192.168.118.168:30702/magicbow/'#"http://192.168.118.120:3306/magicbow-dev/"
    job_base_name = os.environ.get('JOB_BASE_NAME') or "job_93c29706-3ea4-4e1e-a2ae-14fe8bb2cf89"
    build_id = os.environ.get('BUILD_ID') or 1393


    json_obj=jsonfile_to_obj('.report.json')
    try:
        test_result['total']=json_obj.summary.total
    except AttributeError as e:
        loguru.logger.info(e)
        test_result['total'] =0

    try:
        test_result['failed']=json_obj.summary.failed
    except AttributeError as e:
        loguru.logger.info(e)
        test_result['failed'] =0

    try:
        test_result['passed']=json_obj.summary.passed
    except AttributeError as e:
        loguru.logger.info(e)
        test_result['passed'] =0

    try:
        test_result['collected']=json_obj.summary.collected
    except AttributeError as e:
        loguru.logger.info(e)
        test_result['collected'] =0

    test_result['name']=json_obj.root.split(os.sep)[-1] or "noNameFound"

    if test_result['passed']==test_result['collected']:
        test_result['result'] ='true'
    else:
        test_result['result'] ='false'

    test_result['starttime']=datetime.datetime.strftime(datetime.datetime.fromtimestamp(json_obj.created),'%Y-%M-%d %H:%M:%S') or 0
    test_result['endtime']=datetime.datetime.strftime(datetime.datetime.fromtimestamp(json_obj.created)+datetime.timedelta(seconds=json_obj.duration),'%Y-%M-%d %H:%M:%S') or 0
    test_result['elapsedtime']=json_obj.duration
    test_result['status']='None'

    headers = {"Content-Type": "application/json; charset=UTF-8"}

    job={}
    job["code"]=job_base_name
    job["rfRs"]=json.dumps(test_result)

    jobBuild = {}
    jobBuild["code"] = job_base_name
    jobBuild["buildNum"] = build_id
    jobBuild["rfRs"] = json.dumps(test_result)

    # print(json.dumps(jobBuild))

    # 更新jobBuild
    resp=requests.post(server_url + "v1/job/update-build-by-code", data=json.dumps(jobBuild), headers=headers)
    loguru.logger.info(f'更新jobBuild 请求地址为：{server_url}v1/job/update-build-by-code')
    loguru.logger.info(f'更新jobBuild data：{jobBuild}')
    loguru.logger.info(f'更新jobBuild headers {headers}')
    loguru.logger.info(f'更新jobBuild请求结果：{resp.text}')
    # 更新job
    resp=requests.post(server_url + "v1/job/update-job-by-code", data=json.dumps(job), headers=headers)
    loguru.logger.info(f'更新job请求地址为：{server_url}v1/job/update-job-by-code')
    loguru.logger.info(f'更新job data：{jobBuild}')
    loguru.logger.info(f'更新job headers {headers}')
    loguru.logger.info(f'更新job请求结果：{resp.text}')

def jsonfile_to_obj(json_file_path):
    # import json
    # from collections import namedtuple
    # json_file=open(file=json_file_path, mode='r', encoding='utf-8')
    # pyobj=json.load(json_file,object_hook=lambda d: namedtuple('X',d.keys())(*d.values()))
    # return pyobj
    import json
    try:
        from types import SimpleNamespace as Namespace
    except ImportError:
        from argparse import Namespace
    json_obj=open(file=json_file_path, mode='r', encoding='utf-8')
    pyobj=json.load(json_obj,object_hook=lambda d: Namespace(**d))
    return pyobj

def get_magicbow_and_send(param):
    magicbowIp = None
    for par in param:
        print(par)
        if par.find("magicbow") >= 0:
            magicbowArr = par.split("=")
            magicbowIp = magicbowArr[1]
            print(magicbowIp)

    send_test_result_to_devops(magicbowIp)

def cp_result_to_magicbow():
    job_base_name = os.environ.get('JOB_BASE_NAME') or "job_e26450fa-456e-446a-850b-2114acdd64ad"
    build_id = os.environ.get('BUILD_ID') or 63
    shutil.copy("report.html", "/opt/autotest/" + job_base_name + '/' + build_id)
